# This Makefile.PL for X11-MinimalOpenGLViewport was generated by
# Dist::Zilla::Plugin::MakeMaker::Awesome 0.38.
# Don't edit it but the dist.ini and plugins used to construct it.

use strict;
use warnings;

# inserted by Dist::Zilla::Plugin::CheckLib 0.006
use Devel::CheckLib;
check_lib_or_exit(
    header => [ 'GL/gl.h', 'X11/Xlib.h' ],
    lib => [ 'X11', 'GL' ],
    LIBS => '-lGL -lX11',
);

use ExtUtils::MakeMaker;

my %WriteMakefileArgs = (
  "ABSTRACT" => "Bare minimum interactions with XLib needed to create an OpenGL Viewport",
  "AUTHOR" => "Michael Conrad <mike\@nrdvana.net>",
  "CONFIGURE_REQUIRES" => {
    "Devel::CheckLib" => "0.9",
    "ExtUtils::MakeMaker" => 0
  },
  "DISTNAME" => "X11-MinimalOpenGLViewport",
  "LICENSE" => "perl",
  "NAME" => "X11::MinimalOpenGLViewport",
  "PREREQ_PM" => {
    "Carp" => 0,
    "Log::Any" => 0,
    "Log::Any::Adapter::TAP" => 0,
    "Moo" => 2,
    "OpenGL" => 0,
    "Scalar::Util" => 0,
    "Try::Tiny" => 0,
    "XSLoader" => 0,
    "strict" => 0,
    "warnings" => 0
  },
  "TEST_REQUIRES" => {
    "DDP" => 0,
    "IO::Handle" => 0,
    "Log::Any::Adapter" => 0,
    "Math::Trig" => 0,
    "Test::More" => 0,
    "Time::HiRes" => 0
  },
  "VERSION" => "0.00_00",
  "test" => {
    "TESTS" => "t/*.t"
  }
);

%WriteMakefileArgs = (
    %WriteMakefileArgs,
    LIBS => [ '-lGL', '-lX11' ],
);

my %FallbackPrereqs = (
  "Carp" => 0,
  "DDP" => 0,
  "IO::Handle" => 0,
  "Log::Any" => 0,
  "Log::Any::Adapter" => 0,
  "Log::Any::Adapter::TAP" => 0,
  "Math::Trig" => 0,
  "Moo" => 2,
  "OpenGL" => 0,
  "Scalar::Util" => 0,
  "Test::More" => 0,
  "Time::HiRes" => 0,
  "Try::Tiny" => 0,
  "XSLoader" => 0,
  "strict" => 0,
  "warnings" => 0
);

unless ( eval { ExtUtils::MakeMaker->VERSION(6.63_03) } ) {
  delete $WriteMakefileArgs{TEST_REQUIRES};
  delete $WriteMakefileArgs{BUILD_REQUIRES};
  $WriteMakefileArgs{PREREQ_PM} = \%FallbackPrereqs;
}

delete $WriteMakefileArgs{CONFIGURE_REQUIRES}
  unless eval { ExtUtils::MakeMaker->VERSION(6.52) };

WriteMakefile(%WriteMakefileArgs);
